/*
 * Ψɾӥӥ르ꥺ(viterbi algorithm)ˤä
 * ʸζڤꤷƥޡ롣
 *
 *
 * ƤӽФؿ
 *  anthy_mark_borders()
 *
 * Copyright (C) 2006-2007 TABATA Yusuke
 * Copyright (C) 2004-2006 YOSHIDA Yuichi
 * Copyright (C) 2006 HANAOKA Toshiyuki
 *
 */
/*
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
 */
/*
 * ƥ¸ߤmeta_wordĤʤǥդޤ
 * (ΥդΤȤƥ(lattice/«)⤷ϥȥꥹ(trellis)ȸƤӤޤ)
 * meta_wordɤ³դΥΡɤȤʤꡢ¤lattice_node
 * 󥯤Ȥƹޤ
 *
 * ǤνϼĤǤǹޤ
 * (1) դĤġƥΡɤؤãΨ
 * (2) դ()餿ɤäƺŬʥѥ
 *
 */
#if defined(HAVE_CONFIG_H)	/* Patched by G-HAL */
# include "config.h"
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <limits.h>		/* Patched by G-HAL, Thu,20 Nov,2008 */
/* Patched by G-HAL, Wed,25 Feb,2009 */
#if !defined(__STDC_LIMIT_MACROS)
# define	__STDC_LIMIT_MACROS
#endif
#include <stdint.h>

#include "anthy/settings.h"	/* Patched by G-HAL, Fri,17 Oct,2008 */
#include <anthy/alloc.h>
#include <anthy/xstr.h>
#include <anthy/segclass.h>
#include <anthy/splitter.h>
#include <anthy/feature_set.h>
#include <anthy/diclib.h>
#include "wordborder.h"
#include "src-splitter/lattice.h"	/* Patched by G-HAL, Fri,06 Mar,2009 */

static float anthy_normal_length = 20.0; /* ʸδԤĹ */
static void *trans_info_array;

#define NODE_MAX_SIZE 50

/* դΥΡ(ܾ) */
struct lattice_node {
  int border; /* ʸΤɤϤޤ֤ */
  enum seg_class seg_class; /* ξ֤ʻ */


  double real_probability;  /* ˻ޤǤγΨ(ʸ̵) */
  double adjusted_probability;  /* ˻ޤǤγΨ(ʸͭ) */


  struct lattice_node* before_node; /* ܾ */
  struct meta_word* mw; /* ܾ֤бmeta_word */

  struct lattice_node* next; /* ꥹȹ¤ΤΥݥ */
};

struct node_list_head {
  struct lattice_node *head;
  int nr_nodes;
};

struct lattice_info {
  /* ܾ֤ΥꥹȤ */
  struct node_list_head *lattice_node_list;
  struct splitter_context *sc;
  /* ΡɤΥ */
  allocator node_allocator;
};

/*
 */
static void
print_lattice_node(struct lattice_info *info, struct lattice_node *node)
{
  if (!node) {
    printf("**lattice_node (null)*\n");
    return ;
  }
  printf("**lattice_node probability=%.128f\n", node->real_probability);
  if (node->mw) {
    anthy_print_metaword(info->sc, node->mw);
  }
}

static double
get_poisson(double lambda, int r)
{
  int i;
  double result;

  /* פ˥ݥ諒ʬ */
  result = pow(lambda, (double)r) * exp(-lambda);
  for (i = 2; i <= r; ++i) {
    result /= i;
  }

  return result;
}

/* ʸη饹Ĵ */
static double
get_form_bias(struct meta_word *mw)
{
  double bias;
  int r;
  /* wrapƤΤȤ */
  while (mw->type == MW_WRAP) {
    mw = mw->mw1;
  }
 #if 0		/* Patched by G-HAL, Sat,28 Nov,2009 */
  /* ʸĹˤĴ */
  r = mw->len;
  if (r > 6) {
    r = 6;
  }
  if (r < 2) {
    r = 2;
  }
  if (mw->seg_class == SEG_RENTAI_SHUSHOKU &&
      r < 3) {
    /* ؼ */
    r = 3;
  }
  bias = get_poisson(anthy_normal_length, r);
 #else
  if (anthy_settings.anthy_mode.lattice.viterbi.with_poisson) {
    /* ʸĹˤĴ */
    r = mw->len;
    if (r > 6) {
      r = 6;
    }
    if (r < 2) {
      r = 2;
    }
    if (mw->seg_class == SEG_RENTAI_SHUSHOKU &&
	r < 3) {
      /* ؼ */
      r = 3;
    }
    bias = get_poisson(anthy_normal_length, r);
  } else {
    bias = get_poisson( anthy_normal_length, 3 );
  }
 #endif

 #if 1
  /* ƬդƤϸ, Patched by G-HAL, Sat,28 Feb,2009 */
  if (anthy_settings.anthy_mode.lattice.viterbi.decrease_probability_phrase_with_pre_post.sw
      && (mw->wl)
  ) {
    if (0 < mw->wl->part[PART_PREFIX].len) {
      if (0 < mw->wl->part[PART_POSTFIX].len) {
	bias *= anthy_settings.anthy_mode.lattice.viterbi.decrease_probability_phrase_with_pre_post.with_pre_and_post;
      } else {
	bias *= anthy_settings.anthy_mode.lattice.viterbi.decrease_probability_phrase_with_pre_post.with_pre;
      }
    } else if (0 < mw->wl->part[PART_POSTFIX].len) {
      bias *= anthy_settings.anthy_mode.lattice.viterbi.decrease_probability_phrase_with_pre_post.with_post;
    }
  }
 #endif

  return bias;
}

#if 0	/* Patched by G-HAL, Sat,25 Apr,2009 */
static void
build_feature_list(struct lattice_node *node,
		   struct feature_list *features)
#else
static void build_feature_list( struct lattice_node* const node, struct feature_list* features, enum seg_class prev_sc )
#endif
{
  int pc, cc;
  if (node) {
    cc = node->seg_class;
  } else {
    cc = SEG_TAIL;
  }
  anthy_feature_list_set_cur_class(features, cc);
  if (node && node->before_node) {
    pc = node->before_node->seg_class;
  } else {
   #if 0	/* Patched by G-HAL, Sat,25 Apr,2009 */
    pc = SEG_HEAD;
   #else
    pc = prev_sc;
   #endif
  }
  anthy_feature_list_set_class_trans(features, pc, cc);

  if (node && node->mw) {
    struct meta_word *mw = node->mw;
    anthy_feature_list_set_dep_class(features, mw->dep_class);
    anthy_feature_list_set_dep_word(features,
				    mw->dep_word_hash);
    anthy_feature_list_set_mw_features(features, mw->mw_features);
    anthy_feature_list_set_noun_cos(features, mw->core_wt);

  }
  anthy_feature_list_sort(features);
}

static double
calc_probability(int cc, struct feature_list *fl)
{
  struct feature_freq *res, arg;
  double prob;

  /* Ψ׻ */
  res = anthy_find_feature_freq(trans_info_array,
				fl, &arg);
  prob = 0;
  if (res) {
    double pos = res->f[15];
    double neg = res->f[14];
    prob = 1 - (neg) / (double) (pos + neg);
  }
  if (prob <= 0) {
    /* ʸ¸ߤʤѥʤΤ0˶ᤤ */
    prob = 1.0f / (double)(10000 * 100);
  }

  if (anthy_splitter_debug_flags() & SPLITTER_DEBUG_LN) {
    anthy_feature_list_print(fl);
    printf(" cc=%d(%s), P=%f\n", cc, anthy_seg_class_name((enum seg_class)cc), prob);
  }
  return prob;
}

#if 0	/* Patched by G-HAL, Sat,25 Apr,2009 */
static double
get_transition_probability(struct lattice_node *node)
#else
static double get_transition_probability( struct lattice_node* const node, enum seg_class prev_sc )
#endif
{
  struct feature_list features;
  double probability;

  /**/
  anthy_feature_list_init(&features);
 #if 0	/* Patched by G-HAL, Sat,25 Apr,2009 */
  build_feature_list(node, &features);
 #else
  build_feature_list( node, &features, prev_sc );
 #endif
  probability = calc_probability(node->seg_class, &features);
  anthy_feature_list_free(&features);

  /* ʸηФɾ */
  probability *= get_form_bias(node->mw);
  return probability;
}

static struct lattice_info*
alloc_lattice_info(struct splitter_context *sc, int size)
{
  int i;
  struct lattice_info* info = (struct lattice_info*)malloc(sizeof(struct lattice_info));
  info->sc = sc;
  info->lattice_node_list = (struct node_list_head*)
    malloc((size + 1) * sizeof(struct node_list_head));
  for (i = 0; i < size + 1; i++) {
    info->lattice_node_list[i].head = NULL;
    info->lattice_node_list[i].nr_nodes = 0;
  }
  info->node_allocator = anthy_create_allocator(sizeof(struct lattice_node),
						NULL);
  return info;
}

#if 0	/* Patched by G-HAL, Wed,04 Feb,2009, Sat,28 Feb,2009, Sat,25 Apr,2009, Thu,30 Apr,2009 - Fri,01 May,2009, Sat,14 Nov,2009, Tue,17 Nov,2009 */
static void
calc_node_parameters(struct lattice_node *node)
{
  /* бmetaword̵ʸƬȽǤ */
  node->seg_class = node->mw ? node->mw->seg_class : SEG_HEAD;

  if (node->before_node) {
    /* ܤΡɤ */
    node->real_probability = node->before_node->real_probability *
	get_transition_probability(node);
    node->adjusted_probability = node->real_probability *
	(node->mw ? node->mw->score : 1000);
  } else {
    /* ܤΡɤ̵ */
    node->real_probability = 1.0;
    node->adjusted_probability = node->real_probability;
  }
}
#else
static void calc_node_parameters( const struct splitter_context* const sc, struct lattice_node* const node )
{
  if (node->before_node) {
    const struct meta_word* const mw = node->mw;
    node->seg_class = (mw ? mw->seg_class : sc->prev_commit.seg_class);
    {
      enum splitkind_of_metaword	mw_kind;
      const double	mw_score = (mw ? calc_metaword_score( sc, mw, node->before_node->mw, &mw_kind ) : 1.0);
      double		trans_prob = get_transition_probability( node, sc->prev_commit.seg_class );

      /* OCHAIREؽ˳ϲ */
      if (0.0 != anthy_settings.anthy_mode.lattice.biasprob_by_ochaire) {
	enum metaword_type type = node->mw->type;
	if ((MW_ochaire_min <= type) && (type <= MW_ochaire_max)) {
	  static const double rate[SPLITKIND_SIZE] = {
	    [SPLITKIND_OCHAIRE_MIDDLE      ] = 1.00,
	    [SPLITKIND_OCHAIREwoD_MIDDLE   ] = 0.99,
	    [SPLITKIND_OCHAIREwoI_MIDDLE   ] = 0.97,
	    [SPLITKIND_OCHAIREwoIwoD_MIDDLE] = 0.96,
	    [SPLITKIND_OCHAIRE_HEAD        ] = 0.90,
	    [SPLITKIND_OCHAIREwoD_HEAD     ] = 0.89,
	    [SPLITKIND_OCHAIRE_TAIL        ] = 1.00,
	    [SPLITKIND_OCHAIRE_SINGLE      ] = 0.25,
	    [SPLITKIND_OCHAIREwoI_TAIL     ] = 0.50,
	    [SPLITKIND_OCHAIREwoD_TAIL     ] = 0.50,
	    [SPLITKIND_OCHAIREwoIwoD_TAIL  ] = 0.20,
	    [SPLITKIND_OCHAIREwoD_SINGLE   ] = 0.10,
	    [SPLITKIND_CANDHISTORY         ] = 0.00,
	    [SPLITKIND_DEFAULT             ] = 0.00,
	    [SPLITKIND_COMPOUNDHEAD        ] = 0.00,
	    [SPLITKIND_COMPOUNDPART        ] = 0.00,
	    [SPLITKIND_COMPOUND            ] = 0.00,
	    [SPLITKIND_COMPOUNDLEAF        ] = 0.00,
	    [SPLITKIND_OCHAIREwoI_HEAD     ] = 0.00,
	    [SPLITKIND_OCHAIREwoIwoD_HEAD  ] = 0.00,
	    [SPLITKIND_OCHAIREwoI_SINGLE   ] = 0.00,
	    [SPLITKIND_OCHAIREwoIwoD_SINGLE] = 0.00,
	    [SPLITKIND_DELETEDHISTORY      ] = 0.00,
	  };
	  const double base_prob = anthy_settings.anthy_mode.lattice.biasprob_by_ochaire * rate[mw_kind];
	  const double add_prob  = (base_prob / 2.0) * (1.0 + log10( (double)node->mw->cand_hint_learned_freq ) / 2.0 );
	  if (add_prob < 1.0) {
	    trans_prob = trans_prob * (1.0 - add_prob) + add_prob;
	  } else {
	    trans_prob = 1.0;
	  }
	}
      }

      if (anthy_settings.anthy_mode.lattice.viterbi.metaword_effects_sentence) {
	node->real_probability     = node->before_node->real_probability     * trans_prob;
	node->adjusted_probability = node->before_node->adjusted_probability * trans_prob * mw_score;
      } else {
	node->real_probability     = node->before_node->real_probability * trans_prob;
	node->adjusted_probability = node->real_probability * mw_score;
      }
    }
  } else {
    /* Ψĥ꡼κ */
    node->real_probability     = 1.0;
    node->adjusted_probability = 1.0;
  }
  return;
}
#endif

static struct lattice_node*
alloc_lattice_node(struct lattice_info *info,
		   struct lattice_node* before_node,
		   struct meta_word* mw, int border)
{
  struct lattice_node* node;
  node = (struct lattice_node*) anthy_smalloc(info->node_allocator);
  node->before_node = before_node;
  node->border = border;
  node->next = NULL;
  node->mw = mw;

 #if 0	/* Patched by G-HAL, Wed,04 Feb,2009 */
  calc_node_parameters(node);
 #else
  calc_node_parameters( info->sc, node );
 #endif

  return node;
}

static void
release_lattice_node(struct lattice_info *info, struct lattice_node* node)
{
  anthy_sfree(info->node_allocator, node);
}

static void
release_lattice_info(struct lattice_info* info)
{
  anthy_free_allocator(info->node_allocator);
  free(info->lattice_node_list);
  free(info);
}

#if 0		/* Patched by G-HAL, Tue,04 Nov,2008 */
static int
cmp_node_by_type(struct lattice_node *lhs, struct lattice_node *rhs,
		 enum metaword_type type)
{
  if (lhs->mw->type == type && rhs->mw->type != type) {
    return 1;
  } else if (lhs->mw->type != type && rhs->mw->type == type) {
    return -1;
  } else {
    return 0;
  }
}

static int
cmp_node_by_type_to_type(struct lattice_node *lhs, struct lattice_node *rhs,
			 enum metaword_type type1, enum metaword_type type2)
{
  if (lhs->mw->type == type1 && rhs->mw->type == type2) {
    return 1;
  } else if (lhs->mw->type == type2 && rhs->mw->type == type1) {
    return -1;
  } else {
    return 0;
  }
}

#else

/** metaword ӤʥȽꤹ
 *@param[in]		lhs_score	Υ
 *@param[in]		rhs_score	Υ
 *@retval		+1		lhs⤤
 *@retval		0		Ʊ
 *@retval		-1		rhs⤤
 *
 *@attention
 *	ͤ +1, 0, -1 ΣѥΤߤǸƤĽ꤬Τա
 *
 *	Patched by G-HAL, Tue,04 Nov,2008
 */
inline int cmp_node_by_score( int lhs_score, int rhs_score )
{
  if (lhs_score > rhs_score) {
    return +1;
  } else if (lhs_score < rhs_score) {
    return -1;
  }
  return 0;
}


static const struct priority_of_metaword_t VITERBI_PRIORITY_OF_METAWORD = {
  .splitkind_pri[SPLITKIND_OCHAIRE_MIDDLE      ] = { .pri = 37, .sub = 1, },
  .splitkind_pri[SPLITKIND_OCHAIREwoD_MIDDLE   ] = { .pri = 36, .sub = 1, },
  .splitkind_pri[SPLITKIND_OCHAIREwoI_MIDDLE   ] = { .pri = 35, .sub = 1, },
  .splitkind_pri[SPLITKIND_OCHAIREwoIwoD_MIDDLE] = { .pri = 34, .sub = 1, },
  .CAND_COUNTER_MAXLIMIT                         = { .pri =  5, .sub = 0, },
  .CAND_COUNTER_MAXLIMIT_VALUE                   = { .pri =  5, .sub = 0, },
  .splitkind_pri[SPLITKIND_OCHAIRE_HEAD        ] = { .pri = 17, .sub = 1, },
  .splitkind_pri[SPLITKIND_OCHAIREwoD_HEAD     ] = { .pri = 16, .sub = 1, },
  .splitkind_pri[SPLITKIND_OCHAIRE_TAIL        ] = { .pri = 13, .sub = 0, },
  .splitkind_pri[SPLITKIND_OCHAIRE_SINGLE      ] = { .pri = 13, .sub = 0, },
  .splitkind_pri[SPLITKIND_OCHAIREwoI_TAIL     ] = { .pri = 13, .sub = 0, },
  .splitkind_pri[SPLITKIND_OCHAIREwoD_TAIL     ] = { .pri = 13, .sub = 0, },
  .splitkind_pri[SPLITKIND_OCHAIREwoIwoD_TAIL  ] = { .pri = 13, .sub = 0, },
  .splitkind_pri[SPLITKIND_OCHAIREwoD_SINGLE   ] = { .pri = 13, .sub = 0, },
  .OCHAIRE_WEAKMODE                              = { .pri =  5, .sub = 0, },
  .CAND_STRONGMODE                               = { .pri = 13, .sub = 0, },
  .CAND_COUNTER_MINLIMIT                         = { .pri = INT_MAX, .sub = 0, },
  .CAND_WEAKMODE                                 = { .pri =  5, .sub = 0, },
  .splitkind_pri[SPLITKIND_DEFAULT             ] = { .pri =  5, .sub = 0, },
  .splitkind_pri[SPLITKIND_COMPOUNDHEAD        ] = { .pri =  3, .sub = 0, },
  .splitkind_pri[SPLITKIND_COMPOUNDPART        ] = { .pri =  2, .sub = 0, },
  .splitkind_pri[SPLITKIND_COMPOUND            ] = { .pri =  1, .sub = 0, },
  .splitkind_pri[SPLITKIND_COMPOUNDLEAF        ] = { .pri =  5, .sub = 0, },
  .splitkind_pri[SPLITKIND_OCHAIREwoI_HEAD     ] = { .pri =  0, .sub = 0, },
  .splitkind_pri[SPLITKIND_OCHAIREwoIwoD_HEAD  ] = { .pri =  0, .sub = 0, },
  .splitkind_pri[SPLITKIND_OCHAIREwoI_SINGLE   ] = { .pri =  0, .sub = 0, },
  .splitkind_pri[SPLITKIND_OCHAIREwoIwoD_SINGLE] = { .pri =  0, .sub = 0, },
  .splitkind_pri[SPLITKIND_DELETEDHISTORY      ] = { .pri =  0, .sub = 0, },
};


/** ΡɤӤʥӥѡ
 *@param[in]		lhs		ΥΡ
 *@param[in]		rhs		ΥΡ
 *@retval		+1		lhsΨ⤤
 *@retval		0		Ʊ
 *@retval		-1		rhsΨ⤤
 *
 *@attention
 *	ͤ +1, 0, -1 ΣѥΤߤǸƤĽ꤬Τա
 *
 *	Patched by G-HAL
 *		Tue,04 Nov,2008
 *		Wed,05 Nov,2008
 *		Sun,16 Nov,2008
 *		Fri,01 May,2009
 */
static int cmp_node_priority_for_viterbi( struct lattice_node* const lhs, struct lattice_node* const rhs )
{
  int		have_sub_priority = 0;
  int		rhs_minlen = 0;
  int		lhs_minlen = 0;
  const int	rhs_priority_tmp = calc_cmpnode_priority( &VITERBI_PRIORITY_OF_METAWORD, rhs->mw, 0, 0, &have_sub_priority, &rhs_minlen );
  const int	lhs_priority = calc_cmpnode_priority( &VITERBI_PRIORITY_OF_METAWORD, lhs->mw, rhs_priority_tmp, rhs_minlen, &have_sub_priority, &lhs_minlen );
  const int	rhs_priority = calc_cmpnode_priority( &VITERBI_PRIORITY_OF_METAWORD, rhs->mw, lhs_priority    , lhs_minlen, &have_sub_priority, &rhs_minlen );
  if (lhs_priority > rhs_priority) {
    return +1;
  } else if (lhs_priority < rhs_priority) {
    return -1;
  }
  if (have_sub_priority) {
    return cmp_node_by_score( lhs->mw->score, rhs->mw->score );
  }

  return 0;
}
#endif

/*
 * ΡɤӤ
 *
 ** ֤
 * 1: lhsΨ⤤
 * 0: Ʊ
 * -1: rhsΨ⤤
 */
static int
cmp_node(struct lattice_node *lhs, struct lattice_node *rhs)
{
  struct lattice_node *lhs_before = lhs;
  struct lattice_node *rhs_before = rhs;
  int ret;

  if (lhs && !rhs) return 1;
  if (!lhs && rhs) return -1;
  if (!lhs && !rhs) return 0;

  while (lhs_before && rhs_before) {
    if (lhs_before->mw && rhs_before->mw &&
	lhs_before->mw->from + lhs_before->mw->len == rhs_before->mw->from + rhs_before->mw->len) {
     #if 0
      /* ؽ줿Ρɤɤ򸫤 */
      ret = cmp_node_by_type(lhs_before, rhs_before, MW_OCHAIRE);
      if (ret != 0) return ret;

      /* COMPOUND_PARTCOMPOUND_HEADͥ */
      ret = cmp_node_by_type_to_type(lhs_before, rhs_before, MW_COMPOUND_HEAD, MW_COMPOUND_PART);
      if (ret != 0) return ret;
     #else
      /* Ρɾ Patched by G-HAL, Tue,04 Nov,2008, Sun,16 Nov,2008 */
      ret = cmp_node_priority_for_viterbi( lhs_before, rhs_before );
      if (ret != 0) return ret;
     #endif
    } else {
      break;
    }
    lhs_before = lhs_before->before_node;
    rhs_before = rhs_before->before_node;
  }

  /* ǸܳΨ򸫤 */
  if (lhs->adjusted_probability > rhs->adjusted_probability) {
    return 1;
  } else if (lhs->adjusted_probability < rhs->adjusted_probability) {
    return -1;
  } else {
    return 0;
  }
}

/*
 * Υƥ˥Ρɤɲä
 */
static void
push_node(struct lattice_info* info, struct lattice_node* new_node,
	  int position)
{
  struct lattice_node* node;
  struct lattice_node* previous_node = NULL;

  if (anthy_splitter_debug_flags() & SPLITTER_DEBUG_LN) {
    print_lattice_node(info, new_node);
  }

  /* Ƭnode̵̵ɲ */
  node = info->lattice_node_list[position].head;
  if (!node) {
    info->lattice_node_list[position].head = new_node;
    info->lattice_node_list[position].nr_nodes ++;
    return;
  }

  while (node->next) {
    /* ;פʥΡɤɲäʤλ޴ */
    if (new_node->seg_class == node->seg_class &&
	new_node->border == node->border) {
      /* segclassƱǡϤޤ֤Ʊʤ */
      switch (cmp_node(new_node, node)) {
      case 0:
      case 1:
	/* Ψ礭ؽˤΤʤ顢ŤΤ֤*/
	if (previous_node) {
	  previous_node->next = new_node;
	} else {
	  info->lattice_node_list[position].head = new_node;
	}
	new_node->next = node->next;
	release_lattice_node(info, node);
	break;
      case -1:
	/* Ǥʤʤ */
	release_lattice_node(info, new_node);
	break;
      }
      return;
    }
    previous_node = node;
    node = node->next;
  }

  /* ǸΥΡɤθɲ */
  node->next = new_node;
  info->lattice_node_list[position].nr_nodes ++;
}

/* ֳΨ㤤Ρɤõ*/
static void
remove_min_node(struct lattice_info *info, struct node_list_head *node_list)
{
  struct lattice_node* node = node_list->head;
  struct lattice_node* previous_node = NULL;
  struct lattice_node* min_node = node;
  struct lattice_node* previous_min_node = NULL;

  /* ֳΨ㤤Ρɤõ */
  while (node) {
    if (cmp_node(node, min_node) < 0) {
      previous_min_node = previous_node;
      min_node = node;
    }
    previous_node = node;
    node = node->next;
  }

  /* ֳΨ㤤Ρɤ */
  if (previous_min_node) {
    previous_min_node->next = min_node->next;
  } else {
    node_list->head = min_node->next;
  }
  release_lattice_node(info, min_node);
  node_list->nr_nodes --;
}

/* ӥӥ르ꥺѤƷϩ */
static void
choose_path(struct lattice_info* info, int to)
{
  /* ǸޤãܤΤʤǰֳΨ礭Τ */
  struct lattice_node* node;
  struct lattice_node* best_node = NULL;
  int last = to;
  while (!info->lattice_node_list[last].head) {
    /* ǸʸޤܤƤʤä */
    --last;
  }
  for (node = info->lattice_node_list[last].head; node; node = node->next) {
    if (cmp_node(node, best_node) > 0) {
      best_node = node;
    }
  }
  if (!best_node) {
    return;
  }

  /* ܤդˤɤĤʸڤܤϿ */
  node = best_node;
  if (anthy_splitter_debug_flags() & SPLITTER_DEBUG_LN) {
    printf("choose_path()\n");
  }
  while (node->before_node) {
    info->sc->word_split_info->best_seg_class[node->border] =
      node->seg_class;
    anthy_mark_border_by_metaword(info->sc, node->mw);
    /**/
    if (anthy_splitter_debug_flags() & SPLITTER_DEBUG_LN) {
      print_lattice_node(info, node);
    }
    /**/
    node = node->before_node;
  }
}

#if 0	/* Patched by G-HAL, Sat,25 Apr,2009 */
static void
build_graph(struct lattice_info* info, int from, int to)
#else
static void build_graph( struct lattice_info* info, int from, int to, enum seg_class prev_sc )
#endif
{
  int i;
  struct lattice_node* node;
  struct lattice_node* left_node;

  /* ȤʤΡɤɲ */
  node = alloc_lattice_node(info, NULL, NULL, from);
  push_node(info, node, from);

  /* info->lattice_node_list[index]ˤindexޤǤܤäƤΤǤäơ
   * indexܤäƤΤǤϤʤ
   */

  /* Ƥܤ򺸤 */
  for (i = from; i < to; ++i) {
    for (left_node = info->lattice_node_list[i].head; left_node;
	 left_node = left_node->next) {
      struct meta_word *mw;
      /* iʸܤãlattice_nodeΥ롼 */

      for (mw = info->sc->word_split_info->cnode[i].mw; mw; mw = mw->next) {
	int position;
	struct lattice_node* new_node;
	/* iʸܤmeta_wordΥ롼 */

       #if 0		/* Patched by G-HAL, Sun,17 May,2009 */
	if (mw->can_use != ok) {
       #else
	if (mw->can_use < ok) {
       #endif
	  continue; /* 줿ʸζڤޤmetawordϻȤʤ */
	}
	position = i + mw->len;
	new_node = alloc_lattice_node(info, left_node, mw, i);
	push_node(info, new_node, position);

	/* θ䤬¿顢Ψ㤤 */
	if (info->lattice_node_list[position].nr_nodes >= NODE_MAX_SIZE) {
	  remove_min_node(info, &info->lattice_node_list[position]);
	}
      }
    }
  }

  /* ʸ */
  for (node = info->lattice_node_list[to].head; node; node = node->next) {
    struct feature_list features;
    anthy_feature_list_init(&features);
   #if 0	/* Patched by G-HAL, Sat,25 Apr,2009 */
    build_feature_list(NULL, &features);
   #else
    build_feature_list( NULL, &features, prev_sc );
   #endif
    node->adjusted_probability = node->adjusted_probability *
      calc_probability(SEG_TAIL, &features);
    anthy_feature_list_free(&features);
  }
}



void
anthy_mark_borders(struct splitter_context *sc, int from, int to)
{
 #if 0	/* Patched by G-HAL, Sun,16 Nov,2008, Wed,04 Feb,2009, Mon,09 Feb,2009, Fri,20 Feb,2009, Sat,18 Apr,2009, Fri,01 May,2009 */
  struct lattice_info* info = alloc_lattice_info(sc, to);
  trans_info_array = anthy_file_dic_get_section("trans_info");
  build_graph(info, from, to);
  choose_path(info, to);
  release_lattice_info(info);
 #else
  switch (anthy_settings.anthy_mode.lattice.mode) {
  case ANTHY_LATTICE_MODE_VITERBI:
    {
      struct lattice_info* info = alloc_lattice_info(sc, to);
      trans_info_array = anthy_file_dic_get_section("trans_info");
      build_graph( info, from, to, sc->prev_commit.seg_class );
      choose_path(info, to);
      release_lattice_info(info);
    }
    break;
  case ANTHY_LATTICE_MODE_MAXLEN_BY_N_PHRASES:
    choose_path_by_maxlen_n_phrases( sc, from, to );
    break;
  case ANTHY_LATTICE_MODE_MANUAL:
    choose_path_by_manual( sc, from, to );
    break;
  }
  return;
 #endif
}
/* vim:ts=8 sw=2 nomodified:
 */
